/* encrypt flags to be embedded in littletrick.c */

#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void encrypt (uint32_t v[2], uint32_t k[4]) {
    uint32_t v0=v[0], v1=v[1], sum=0, i;           /* set up */
    uint32_t delta=0x9E3779B9;                     /* a key schedule constant */
    uint32_t k0=k[0], k1=k[1], k2=k[2], k3=k[3];   /* cache key */
    for (i=0; i<32; i++) {                         /* basic cycle start */
        sum += delta;
        v0 += ((v1<<4) + k0) ^ (v1 + sum) ^ ((v1>>5) + k1);
        v1 += ((v0<<4) + k2) ^ (v0 + sum) ^ ((v0>>5) + k3);
    }                                              /* end cycle */
    v[0]=v0; v[1]=v1;
}

int main(int argc, char **argv) {
        uint32_t v[2] = { 0, 0 };
	uint32_t k[4] = { 0x57438952, 0xabde38cb, 0x3243ba30, 0x5635649f }; 
	int i;

	if (argc != 3 || strlen(argv[1]) != 8) {
		fprintf(stderr, "Usage: %s 8-byte-flag password\n", argv[0]);
		exit(1);
	}

	for (i=0; i<4; i++) {
		v[0] |= ((int)argv[1][2*i] & 0xff) << (8*i);
		v[1] |= ((int)argv[1][2*i+1] & 0xff) << (8*i);
	}

	encrypt(&v, &k);
	printf ("#define V1 0x%08x\n#define V2 0x%08x\n", v[0], v[1]);
	printf ("#define P \"%s\"\n", argv[2]);
}
